import requests
from utils.output import *

class cve_2021_22005_check:

    def __init__(self, url_text, result_text, update_date):
        _url = str(url_text.text())
        if _url.endswith("/"):
            self.url = _url[:-1]
        else:
            self.url = _url
        self.result_text = result_text
        self.update_date = update_date
        if self.url == "":
            self.update_date.emit(output_format("ERROR", "What's your url?"))

    def check(self):
        try:
            header = {
                "Content-Type": "application/json"
            }
            req1 = requests.get(self.url, verify=False)
            req2 = requests.post(self.url + "/analytics/telemetry/ph/api/hyper/send?_c&_i=test", data="test_data", headers=header, verify=False)
            if (req1.status_code == 200 and req2.status_code == 201 and "VMware vSphere" in req1.text and len(req2.text) == 0):
                self.update_date.emit(output_format("SUCCESS", "The vCenter system is vulnerable to CVE-2021-22005!"))
            else:
                self.update_date.emit(output_format("FAILED", "The vCenter system is not vulnerable to CVE-2021-22005.Please check the network then retry or attempt manual exploitation."))
        except Exception as e:
            self.update_date.emit(output_format("FAILED", f"Please check the network then retry. Error message: {str(e)}"))